<?php 
if( false == function_exists( 'display' )) {
	function display( $arr ) {
		echo( '<pre>' );
			print_r( $arr );
		echo( '</pre>' );
	}//end function
} 

function validip( $ip ) {
	if( !empty( $ip ) && ip2long( $ip ) != -1 ) {
		$reserved_ips = array (
			array( '0.0.0.0','2.255.255.255' ),
			array( '10.0.0.0','10.255.255.255' ),
			array( '127.0.0.0','127.255.255.255' ),
			array( '169.254.0.0','169.254.255.255' ),
			array( '172.16.0.0','172.31.255.255' ),
			array( '192.0.2.0','192.0.2.255' ),
			array( '192.168.0.0','192.168.255.255' ),
			array( '255.255.255.0','255.255.255.255' )
		);
		 
		foreach( $reserved_ips as $r ) {
			$min = ip2long( $r[0] );
			$max = ip2long( $r[1] );
			if (( ip2long( $ip ) >= $min ) && ( ip2long( $ip ) <= $max )) return false;
		}
		 
		return true;
	} else {
		return false;
	}
}
 
function getip() {
	if( validip( $_SERVER["HTTP_CLIENT_IP"] )) {
		return $_SERVER["HTTP_CLIENT_IP"];
	}
	 
	foreach( explode( ",", $_SERVER["HTTP_X_FORWARDED_FOR"] ) as $ip ) {
		if( validip( trim( $ip ))) {
			return $ip;
		}
	}

	if( validip($_SERVER["HTTP_X_FORWARDED"] )) {
		return $_SERVER["HTTP_X_FORWARDED"];
	} elseif( validip($_SERVER["HTTP_FORWARDED_FOR"] )) {
		return $_SERVER["HTTP_FORWARDED_FOR"];
	} elseif( validip($_SERVER["HTTP_FORWARDED"] )) {
		return $_SERVER["HTTP_FORWARDED"];
	} elseif( validip($_SERVER["HTTP_X_FORWARDED"] )) {
		return $_SERVER["HTTP_X_FORWARDED"];
	} else {	 
		return $_SERVER["REMOTE_ADDR"];
	}
}

function curlPostToAnotherDomain( $arrValues = array(), $strAnotherDomainPage = '', $strReturnValueFormat = 'array' ) {
	//$strReturnValueFormat = 'object'
	
	if( !extension_loaded( "curl" )) {
		echo( '<font color=\'red\'>cURL extension is not loaded in PHP.ini file.</font>' );
		exit();	    
	} 

	//extract( $arrValues ); -> extract the values from array to individual variables
	//display($arrValues);	
	$arrFields = array();
	if( 0 < sizeof( $arrValues )) {
		foreach( $arrValues as $strIndex => $strValue ) {
			$arrFields[$strIndex] = urlencode( $strValue );
		}
	}
	
	$strFieldsString = '';
	foreach( $arrFields as $strKey => $strValue ) { $strFieldsString .= $strKey .'=' . $strValue . '&'; }
	$strFieldsString = rtrim( $strFieldsString, '&' );
	
	//display($strFieldsString);
	//open connection
	$ch = curl_init();
	
	$arrResult = array();
	if( $ch ) {
		//set the url, number of POST vars, POST data
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_URL, $strAnotherDomainPage );//'http://domain.com/get-post.php';
		curl_setopt( $ch, CURLOPT_POST, count( $arrFields ));
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $strFieldsString );
		
/*		display( $strAnotherDomainPage );
		display( count( $arrFields ));
		display( $strFieldsString );*/
		//execute post
		if( false === ( $arrResult = curl_exec( $ch ))) {
			 echo '<font color=\'red\'>Curl error: ' . curl_error($ch) . '</font>';	
			 exit();		
		}		
		
		//display( $arrResult );
		
		//close connection
		curl_close($ch);
	} else {
		echo( '<font color=\'red\'>Error in curl initialization.</font>' );
		exit();
	}
	
	if( 'object' == $strReturnValueFormat ) {
		return json_decode( $arrResult );
	} else {
		return json_decode( $arrResult, true );
	}
}//end function
?>