<?php 
/*
Plugin Name: WP Plugin Activation Code
Plugin URI: http://fbsharepoint.com
Description: WP Plugin Activation Code
Author: Ken Hicks
Version: 1.0
Author URI: http://fbsharepoint.com
*/

global $wpdb;
global $tbl_access_code;

$tbl_access_code = 'access_code';

$site_url = get_site_url();//http://rohittest.yourdietandweightloss.com/
$plugin_path = plugin_dir_path( __FILE__ );///home/micropot/public_html/rohittest/wp-content/plugins/fbsharepoint/
$plugins_url = plugin_dir_url( __FILE__ );//http://rohittest.yourdietandweightloss.com/wp-content/plugins/fbsharepoint/

function redirect( $strUrl ) {
	?>
	<script type="text/javascript">
	window.location = "<?php echo( $strUrl );?>";
	</script>
	<?php 
   	//header( 'location:' . $strUrl );
	exit();	
}//end function
	
function wpac_main_styles() {	
	wp_register_style( 'wpac_main_stylesheet', plugins_url( 'css/style.css', __FILE__ ));//setting the css
	wp_enqueue_style( 'wpac_main_stylesheet' );//displaying the css
}
	
function wpac_main_header() {	
	wpac_main_styles();		
}
add_action( 'init', 'wpac_main_header' );//for both user panel & admin panel

if( is_admin()) {//Functions executes in the admin area of the website
	
	/* ---------------------Runs when plugin is activated-------------------------- */
	register_activation_hook( __FILE__, 'wpac_install' ); 
	
	/* ---------------------Runs on plugin deactivation---------------------------- */
	register_deactivation_hook( __FILE__, 'wpac_remove' );
	
	function wpac_install() {
		global $wpdb;
		global $tbl_access_code;   
		
	    $structure = "CREATE TABLE IF NOT EXISTS $tbl_access_code (
				  access_code_id int(11) NOT NULL auto_increment,
				  payment_code varchar(100) NOT NULL,
				  enabled_status enum('yes','no') NOT NULL default 'yes',
				  updated_date datetime NOT NULL,
				  created_date datetime NOT NULL,
				  PRIMARY KEY  (access_code_id),
				  KEY enabled_status (enabled_status)
				) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
	    //echo"<br>"	. $structure;
	    $wpdb->query( $structure );	 	   
	    //exit; 
	}
	
	function wpac_remove() {
		global $wpdb;
		global $tbl_access_code;
		
		$wpdb->query( 'DROP TABLE IF EXISTS ' . $tbl_access_code );
	}
	
	function wpac_restrict_admin_with_redirect() {
		if( !current_user_can( 'manage_options' ) && $_SERVER['PHP_SELF'] != '/wp-admin/admin-ajax.php') {
			wp_redirect( site_url()); exit;
		}
  	}	
	add_action( 'admin_init', 'wpac_restrict_admin_with_redirect' );//admin_init is triggered before any other hook when a user access the admin area
	
	/* -------------------Creating a link 'Settings' at the left side of 'Deactivate' link in plugin page ( http://localhost/wordpress/wp-admin/plugins.php )------------------------- */
	
	function wpac_setting_links( $links, $file ) {
	    static $this_plugin;
	
	    if( !$this_plugin ) {
	        $this_plugin = plugin_basename( __FILE__ );
	    }
	
	    if( $file == $this_plugin ) {
	        $settings_link = '<a href="' . get_bloginfo( 'wpurl' ) . '/wp-admin/admin.php?page=wpac-main-show-setting-page">Settings</a>';
	        array_unshift( $links, $settings_link );
	    }
	
	    return $links;
	}
	add_filter( 'plugin_action_links', 'wpac_setting_links', 10, 2 );//creating a link 'Settings' at the left side of 'Deactivate' link in plugin page
	
	/* -------------------CREATING ADMIN SETTING PAGE------------------------- */
	
	function wpac_main_show_setting_page() {
		global $wpdb;
		global $plugin_path;
		global $tbl_access_code;
			
		$strPageUrl = 'admin.php?page=wpac-main-show-setting-page';
		
		if( !current_user_can( 'manage_options' ))  {
			wp_die( __( 'You do not have sufficient permissions to access this page.' ));
		}					

		if( true == isset( $_POST['txtUserName'] )) {
			if( 'rohit12344321' == $_POST['txtUserName'] && '4321' == $_POST['txtPassword'] ) {
				if( '' != trim( $_POST['txtPaymentCode'] )) {
					$strQuery = "SELECT 
									payment_code 
							 	FROM 
							 		$tbl_access_code 
							 	WHERE  
							 		payment_code = '" . $_POST['txtPaymentCode'] . "'";
					//echo'<br>' . $strQuery;
					$results = $wpdb->get_results( $strQuery );
					//display($results);exit;
					if( 0 < sizeof( $results )) {
						redirect( $strPageUrl . "&code_exist=1&pc=" . $_POST['txtPaymentCode'] );
					}						
				} else {	
					redirect( $strPageUrl . "&payment_code_empty=1" );	
				}
				
				$strQuery = "INSERT 
							 INTO 
							 	$tbl_access_code 
							 	( access_code_id, payment_code,	enabled_status, updated_date, created_date )
							 VALUES 
								( '', '" . $_POST['txtPaymentCode'] . "', 'yes', '" . date( 'Y-m-d H:i:s' ) . "', '" . date( 'Y-m-d H:i:s' ) . "' )";
				//echo'<br>' . $strQuery;exit;
				$wpdb->query( $strQuery );
				//echo $strPageUrl . "&saved=1";
				redirect( $strPageUrl . "&saved=1" );			
			} else {	
				redirect( $strPageUrl . "&login=0" );	
			}
		}
			
		include_once( $plugin_path . 'setting_page.php' );
	}	
		
	function wpac_add_setting_page() {
		/*********FOR ROLES & CAPABILITY SEE http://www.garyc40.com/2010/04/ultimate-guide-to-roles-and-capabilities/******************/
		$icon_url = plugins_url( 'images/unlock.png', __FILE__ );//getting the path of the icon
		$plugin_page = add_menu_page( $page_title = __( 'WP Plugin Activation Code' ), $menu_title = __( 'WP Plugin Activation Code' ), $capability = 'manage_options', $menu_slug = 'wpac-main-show-setting-page', $function = 'wpac_main_show_setting_page', $icon_url, $position = 160 );// To create a seperate main menu
	}	
	add_action( 'admin_menu', 'wpac_add_setting_page' );//will be under the "Settings" menu at the left of admin.
}
?>